import { defineStore } from "pinia";

export const useCStore = defineStore("Control Store", {
  state: () => {
    return {
      env: "Mountain Car",
      envs: ["Mountain Car", "Cartpole", "Acrobot", "Pendulum"],
      metric: "random",
      metircs: ["random", "regular", "max acquisition", "improvement"],
      acq_fun: "Expected Improvement",
      acq_funs: [
        "Expected Improvement",
        "Probability of Improvement",
        "Upper Confidence Bound",
      ],
      nr_episodes: 50,
      nr_runs: 10,
      metric_parameter: 0.5,
      sendWeights: false,
      runner: false,
      fixed_seed: false,
      save_result: false,
    };
  },
  getters: {
    getEnv: (state) => state.env,
    getMetric: (state) => state.metric,
    getNrEpisodes: (state) => state.nr_episodes,
    getNrRuns: (state) => state.nr_runs,
    getMetricParameter: (state) => state.metric_parameter,
    getSendWeights: (state) => state.sendWeights,
    getRunner: (state) => state.runner,
    getAcq: (state) => state.acq_fun,
  },
  actions: {
    setEnv(value) {
      this.env = value;
    },
    setMetric(value) {
      this.metric = value;
    },
    setNrEpisodes(value) {
      this.nr_episodes = value;
    },
    setNrRuns(value) {
      this.nr_runs = value;
    },
    setMetricParameter(value) {
      this.metric_parameter = value;
    },
    setSendWeights() {
      this.sendWeights = !this.sendWeights;
    },
    setRunner() {
      this.runner = !this.runner;
    },
    setAcq(value) {
      this.acq_fun = value;
    },
  },
});
